/*******************************************************************************************************************
Copyright (c) 2012 Cycling '74

Permission is hereby granted, free of charge, to any person obtaining a copy of this software
and associated documentation files (the "Software"), to deal in the Software without restriction,
including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************************************************/

#include "XPHDConstants.h"
#include "AUEffectBaseMultichannel.h"
#include <vector>
using std::vector;


// Change these depending on your gen patcher's export name
#include "gen_exported.h"
using namespace gen_exported;


class XPHDPlugin;

class XPHDPluginKernel : public AUKernelBaseMultichannel {
public:
	XPHDPluginKernel(XPHDPlugin * inAudioUnit);
	virtual ~XPHDPluginKernel();
	
	
	virtual void Process(
		const vector<const Float32 *> &inSourceP,
		const vector<Float32 *> &inDestP,
		UInt32 inFramesToProcess,
		bool &ioSilence
	);

	XPHDPlugin *plug;
	int bufferSize;
	vector< t_sample * > inputBuffers;
	vector< t_sample * > outputBuffers;
};

class XPHDPlugin : public AUEffectBaseMultichannel {
public:
	XPHDPlugin(AudioUnit component);
	virtual ~XPHDPlugin();
	
	virtual OSStatus Version() { return XPHD_VERSION; }
	virtual OSStatus Initialize();
	virtual AUKernelBaseMultichannel * NewKernel() { return new XPHDPluginKernel(this); }
	virtual ComponentResult GetParameterInfo(
		AudioUnitScope inScope,
		AudioUnitParameterID inParameterID,
		AudioUnitParameterInfo &outParameterInfo
	);
	virtual ComponentResult SetParameter(
		AudioUnitParameterID inID,
		AudioUnitScope inScope,
		AudioUnitElement inElement,
		AudioUnitParameterValue inValue,
		UInt32 inBufferOffsetInFrames
	);
	
	CommonState *gen;
	int nParams;
};
